unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, ap_Types,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, ScrMemo, IDEMain,
  atScript, atScripter;

type
  TForm1 = class(TForm)
    IDEScripter1: TIDEScripter;
    IDEMemo1: TIDEMemo;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure _GetCursorPos(AMachine: TatVirtualMachine);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  IDEScripter1.SourceCode := IDEMemo1.Lines;
  IDEScripter1.Execute;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  IDEScripter1.SystemLibrary.defineMethod('GetCursorPos', 1, atScript.tkInteger,
    nil, _GetCursorPos, false, 0, 'lPoint:TPoint').SetVarArgs([0]);
  IDEScripter1.AddLibrary(TatTypesLibrary);
end;

procedure TForm1._GetCursorPos(AMachine: TatVirtualMachine);
var
  Param0: TPoint;
  AResult: boolean;
begin
  AResult := GetCursorPos(Param0);
  AMachine.ReturnOutputArg(AResult);
  AMachine.SetInputArg(0, NativeUInt(TPointWrapper.Create(Param0)));
end;

end.
